;EXAM1.ASM	8 November 93

;Example use of the ATE.ASM module for the Logic Analyzer
; models 32XX/64XX/128XX.

;This example will load a settings file, perform a capture
;of data, and then save the data to a file.

;Compile this with either IBM/Microsoft MASM or Borland TASM
;Link with ATE.OBJ

	;Address of ATE routine entry point
	EXTRN	ATESTAR:FAR
	;Address of Command Parameter
	EXTRN	COMMAND:BYTE
	;Address of Command execution Status
	EXTRN	STATUS:BYTE
	;Address of Valid Trigger Status
	EXTRN	CALON:BYTE
	;Address of Data Segment containing acquired data
	EXTRN	DSEGMENT:WORD
	;Address of Setting file load status
	EXTRN	STATUS1:BYTE
	;Address of Settings file name
	EXTRN	SETTINGFILE:BYTE

;DATA AREA Definition ---------------------------------------------------
;CAUTION: The first and last 32 bytes of data are uncertain data.
;This data area should start at a zero offset for a given segment address.
;This is because the ATE.ASM routines assume that the offset for the
;data buffer is at location 0.  The easiest way to do this is to have
;it at the start of the program.

;64K Data buffer for 32 channel and 64 channel models including
; backup channels or data buffer for 128 channel models
_BUF1	SEGMENT WORD PUBLIC 'BUF1'
databuf	db	0FFFFh dup (0)
_BUF1	ENDS
;64K Backup data buffer for 128 channel models
_BUF2	SEGMENT WORD PUBLIC 'BUF2'
buf2	db	0FFFFh dup (0)
_BUF2	ENDS

DGROUP	GROUP	_DATA,STACK
	ASSUME	CS:_Exam, DS:_DATA, SS:STACK

STACK	SEGMENT	PARA STACK 'STACK'
	db	200H DUP(?)
STACK	ENDS

_DATA	SEGMENT WORD PUBLIC 'DATA'
setfile		DB	'LOGIC.SET',0,'   '	;total length=13
fday		DB	'no'
fhour		DB	'na'
fmin		DB	'me'
fsec		DB	'00'
fnameend	DB	'.dat',0
fhandle		DW	0
numten		DB	10
_DATA	ENDS

_Exam	SEGMENT WORD PUBLIC 'CODE'

Start:
;setup DS Register for local data
	MOV	ax,_DATA
	MOV	ds,ax

;setup ES Register to point into ATE.ASM data structure
	MOV	ax,SEG ATESTAR
	MOV	es,ax

;setup data buffer for ate.asm
	MOV	ax,seg databuf
	MOV	word ptr es:[dsegment],ax

;LOAD IN SETTINGS FILE
;Set COMMAND = 0, setup file name, and then call ATESTAR
;assume that the file LOGIC.SET Exists and loads in correctly
	mov	byte ptr es:[command],0
	MOV	si,OFFSET setfile
	MOV	di,OFFSET settingfile
	MOV	cx,12
	rep	movsb
	call	atestar

;INITIALIZE LOGIC ANALYZER WITH LOADED SETTINGS
;Set COMMAND = 1, then call ATESTAR
	mov	byte ptr es:[command],1
	call	atestar

;WAIT UNTIL DATA IS AVAILABLE
;Set COMMAND = 2, then call ATESTAR, then check if done
checkstat:
	mov	byte ptr es:[command],2
	call	atestar
	test	byte ptr es:[status],00000100b
	JZ	checkstat
GoSave:
;save the acquired data to a file named by the current
; date and time : DDHHMMSS.DAT
; DD=day HH=hour MM=minutes SS=seconds

;build the file name
    ;get system date, DD is returned in DL reg
	MOV	ax,2a00h
	INT	21h
	MOV	al,dl
	XOR	ah,ah
	IDIV	[numten]
	ADD	al,'0'
	MOV	fday,al
	ADD	ah,'0'
	MOV	fday+1,ah
    ;get system time
	MOV	ax,2c00h
	INT	21h
    ;save the hour
	MOV	al,ch
	XOR	ah,ah
	IDIV	[numten]
	ADD	al,'0'
	MOV	fhour,al
	ADD	ah,'0'
	MOV	fhour+1,ah
    ;save the minutes
	MOV	al,cl
	XOR	ah,ah
	IDIV	[numten]
	ADD	al,'0'
	MOV	fmin,al
	ADD	ah,'0'
	MOV	fmin+1,ah
    ;save the seconds
	MOV	al,dh
	XOR	ah,ah
	IDIV	[numten]
	ADD	al,'0'
	MOV	fsec,al
	ADD	ah,'0'
	MOV	fsec+1,ah

;create and open a file
	MOV	ax,3c00h
	MOV	cx,0
	MOV	dx,offset fday
	INT	21h
;save the file handle
	MOV	fhandle,ax
;write to the file
	;get the handle
	MOV	bx,fhandle
	;length of block to write
	MOV	cx,4000h
	;build pointer to the block
	PUSH	DS
	MOV	dx,offset databuf
	MOV	AX,seg databuf
	MOV	DS,AX
	MOV	ax,4000h
	INT	21h
	POP	DS
;close the file
	MOV	bx,fhandle
	MOV	ax,3e00h
	INT	21h
exit:
;end process to exit to DOS
	MOV	AX,4C4CH
	INT	21h

_Exam	ENDS
	END	Start
